/* matrix.h */

bool mat_3D_init(Matrix * threeD[], const elem_t depth, 
             const matrix_dim row_count, const matrix_dim col_count,
             const string title, const string levels[]);
void copy_to_submatrix(Matrix * submatrix[], Matrix * original[],
          const chose_t * row_select, const chose_t * col_select,
          const chose_t * depth_select);
bool mat_chosen(const chose_t * parti_s, const chose_t * query_s, 
          chose_t * level_s[], Matrix ** all_data[], 
          Matrix ** chosen[], string parti_name[], string query_name[],
          TransFuncType transform_to_apply);
string mat_title(const Matrix * mat);
string mat_level(const Matrix * mat);
bool inc_mat_col(Matrix * mat);
bool dec_mat_col(Matrix * mat);
bool mat_set(Matrix * mat, const matrix_dim row, const matrix_dim col,
          const real value);
real mat_value(const Matrix * mat, const matrix_dim row, 
          const matrix_dim col);
matrix_dim num_cols(const Matrix * mat);
matrix_dim num_rows(const Matrix * mat);
bool mat_resize(Matrix * mat, const matrix_dim new_rows, 
          const matrix_dim new_cols);
/* -- sums using matrices -- */
real sumcol(Matrix * mat, const matrix_dim column);
real sumrow(Matrix * mat, const matrix_dim row);
real sum3Dcol(Matrix * arr[], const matrix_dim column, 
            const matrix_dim howdeep);
real sum3Drow(Matrix * arr[], const matrix_dim row, const matrix_dim howdeep);
real sumdepth(Matrix * arr[], const matrix_dim row, const matrix_dim col, 
            const matrix_dim depth);
void mat_forall(Matrix * mat[], void (*func)(real *), 
      const matrix_dim max_depth);

