/* print.h */

typedef struct {
           string      srcvar;     /* Source of variation */
           string      smallname;  /* For use with showall option in 3way() */
           matrix_dim  degfreed;   /* Degrees of freedom  */
           real        sumsquare;  /* Sum of squares */
           real        meansquare; /* Mean square */
           real        f_value;    /* F value */
           bool        signifdiff; /* F > crit val */
           real        critval;    /* critical value of F */
        } ATableEntry;
typedef struct { 
           chose_t groups;
           real    mean;
        } Means;
typedef enum show {                                 \
           Err=0, Format=1, Example=2, Sh=3, Awk=4, \
           Refer=5, Author=6, f2c=7, Overview=8     \
        } show;

void set_height(const ScreenSize new_size);
ScreenSize height_display(void);
void set_width(const ScreenSize new_size);
ScreenSize width_display(void);
void init_print_count(void);
bool end_display(void);
bool end_menu(void);
void print_raw_data(const unsigned maxpartiwidth, 
            const ScreenSize maxquerywidth, 
            const Matrix * data, const string parti_name[],
            const string query_name[], const string subtitle, 
            const bool reset_line_count);
void print_ave_data(const real average[], const matrix_dim howmany,
            const ScreenSize maxwidth, const string name[], 
            const bool byparti, const string levels, const string title, 
            const string subtitle, const bool reset_line_count);
void print_both_ave(const string levels, const string title, 
            const string subtitle, const real average, 
            const bool reset_line_count);
void ANOVATable(ATableEntry entry[], const unsigned int size, 
            const string title, const string datatype, 
            const string level_str, const string note,
            FILE * outfile);
int show_means(const Means average[], const matrix_dim howmany, 
            const string title, const string subtitle, const string meantype, 
            const string levels, const bool showall, FILE * outfile);
void display_file(show which_file);
void limits(void);
int PrintLine(FILE * where, const char what, const ScreenSize fieldwidth, 
    const string after);
int NewLine(unsigned howmany, FILE * outfile);
bool s_m_value(void);
void s_m_toggle(void);
bool start_menu(void);
bool PrintTitle(FILE * outfile, const string title, const ScreenSize width);
