/* select .h */

/* -- select -- */
bool select_init(void);
bool s_init(chose_t * select, const string title, const elem_t max, 
            const elem_t max_len);
void s_destroy(chose_t * select);
bool s_remove(chose_t * where);
bool s_append(const string name, chose_t * where, const bool selected);
bool s_assign(const chose_t * select, const elem_t elem, const bool value);

/* s_size(): maximum allowed size */
elem_t s_size(const chose_t * select);

/* s_count(): how many elements are on */
elem_t s_count(const chose_t *select);

void s_toggle(chose_t * select, const elem_t elem);
bool s_value(const chose_t * select, const elem_t elem);
void s_all_select(chose_t * select, const bool value);
bool s_all_are_on(const chose_t * select);
bool s_select_menu(chose_t * select);
elem_t s_print(const chose_t * select, const bool print_all, 
            const bool val_to_print, elem_t printed[], 
            const ScreenSize displaywidth);

/* s_name(): name assigned to element `elem' of `select' */
string s_name(const chose_t * select, const elem_t elem, bool * err);

/* s_title(): what data does `select' represent? */
string s_title(const chose_t * select);

/* -- name_list -- */
void init_name_list(string list[], const matrix_dim size);
bool make_name_list(string list[], const chose_t * source);
void free_name_list(string list[], const matrix_dim size);
void make_level_list(char level_list[], const chose_t * source, 
            const string level_name[]);
bool print_name_list(const string name_list[], const elem_t maxsize,
            ScreenSize indent, const ScreenSize maxwidth, const string title,
            FILE * outfile);
